/* SC Dense Code. -- 
A semistatic word-based byte oriented compressor for text files.

Programmed by Antonio Faria
Copyright (C) 2006  Nieves R. Brisaboa, Gonzalo Navarro, Antonio Faria and Jos R. Param
Author's contact: antonio.fari@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*-----------------------------------------------------------------------
 File    : compressor
 Function  : Main file of the compressor
 ------------------------------------------------------------------------*/


#include <string.h>
#include <stdlib.h>
#include <math.h>

#include <malloc.h>
#include <stdio.h>

#include "constants.h"
#include "valstring.h"
#include "BufferedReader.h"
#include "hash.h"
#include "BufferedWriter.h"
#include "compatibility.h"
#include "timer.h"

#if 0
static void swap(int *x,
		 int *y)
{
  int temp;

  temp = *x;
  *x = *y;
  *y = temp;
  return;
}
#endif

#define swap( x, y ) { int temp; temp=*(x); *(x)=*(y); *(y)=temp; }

#define MAX 256
//#define MAX_UNSIGNED_LONG_INT 4294967295
#define MAX_UNSIGNED_LONG_INT 2147483647

	unsigned long *positionInTH;

    unsigned long addrInTH;		//the value return by calls to Search(hashTable)
	unsigned long zeroNode;		//The number of words that have been added to  the vocabulary.

	void initialize (unsigned long sizeVoc);

	void mainCompressor (char* infile, char* outfile, unsigned long N_val);
	void GeneraCodigosSCNumero (unsigned long int v, int s);
    int findBestS_Secuencial(int B, long int *freqList, unsigned long int longFrec);
    unsigned long computeSizeS(int s, int c, long int *freqList, unsigned long int n, unsigned long int SIZEBEST);
